#ifndef _GLOBL_H_
#define _GLOBL_H_

#ifndef EXTERN
#define EXTERN extern
#endif

// Define this to makes things worse on my hardware despite the
// fact that the effort made should speed up everything.
// Consult NVidias documentation about this extension.
// Do not define this for a portable program since the availability
// of the extension is not checked.
//
// There are two questions open:
// When should one use glVertexArrayRangeNV (and glFlushVertexArrayRangeNV)?
// At every rendered frame or only when the memory changes?
//
// Should one announce the Vertices and the normals in separate
// calls? Probably yes. 


#undef USE_GL_NV_VERTEX_ARRAY_RANGE

#include <windows.h>
#include <time.h>

#include <gl\gl.h>   // Header File For The OpenGL32 Library
#include <gl\glu.h>   // Header File For The GLu32 Library
#include <gl\glaux.h>  // Header File For The Glaux Library

#include "glext.h"
#include "wglext.h"

/* windows */
EXTERN HDC   hDC;  // Private GDI Device Context
EXTERN HWND  hWnd;  // Holds Our Window Handle
EXTERN HINSTANCE hInstance;  // Holds The Instance Of The Application
EXTERN PFNWGLALLOCATEMEMORYNVPROC  wglAllocateMemoryNV;
EXTERN PFNWGLFREEMEMORYNVPROC  wglFreeMemoryNV;

/* ogl */
EXTERN HGLRC  hRC;  // Permanent Rendering Context
EXTERN PFNGLVERTEXARRAYRANGENVPROC glVertexArrayRangeNV;
EXTERN PFNGLFLUSHVERTEXARRAYRANGENVPROC glFlushVertexArrayRangeNV;

/* our stuff */
EXTERN bool fullscreen; // Fullscreen Flag Set To Fullscreen Mode By Default
EXTERN unsigned long framecount;
EXTERN time_t start, stop;

EXTERN double Xmin, Xmax, Ymin, Ymax;
#define XDOTS  101
#define YDOTS  101

GLvoid	
ReSizeGLScene(GLsizei width, GLsizei height);
int	
InitGL(GLvoid);
int 
ReadSceneData(void);
int 
DrawGLScene(GLvoid);
GLvoid 
KillGLWindow(GLvoid);
#undef EXTERN

#ifndef M_PI
#define M_PI 3.14159265
#endif

#endif
