
#include <math.h>

#include "projfile.h"
#include "global.h"

static float f(double x, double y)
{
  double r;

  r = sqrt( x*x + y*y );
  if(r) return (float) (10.0 * sin(r)/r);
  else return 10.0f;
}

static double sqr(double x) {return x*x;}
static double sign(double x) {if(x<0) return -1; else return +1;}

char* ReadDots(unsigned long &dtcount,float* &dt )
{
  static char errmsg[300];
  unsigned long i, dx, dy;
  float x,y,z;
 
  dtcount = XDOTS * YDOTS;

  Xmin = Ymin = -15.0;
  Xmax = Ymax = +15.0;

#ifdef USE_GL_NV_VERTEX_ARRAY_RANGE
  dt = (float*) wglAllocateMemoryNV( 3 * dtcount * sizeof(float), 
				     0, 0.1f, 1);

  if(0 == dt) {
    MessageBox(NULL,"Failed to allocate space for dots/vertices via wglAllocateMemoryNV.\nUsing normal malloc/new instead.","ReadDots",MB_OK | MB_ICONINFORMATION);
    dt = new float[3*dtcount];
  }
#else
  dt = new float[3*dtcount];
#endif

  if (0==dt)
    {
      return "Out of Mem allocating mem for dots.\r\n";
    }
  
  i = 0;
  for(dx=0; dx<XDOTS; dx++) {
    x = (float)(Xmin + (Xmax-Xmin) 
		* ( ((double)dx) / ((double)(XDOTS-1)) ) 
		);
    for(dy=0; dy<YDOTS; dy++) {
      y = (float)(Ymin + (Ymax-Ymin) 
		  * ( ((double)dy) / ((double)(YDOTS-1)) ) 
		  );
      z = f(x,y);
      dt[3*i]=(float)x;
      dt[3*i+1]=(float)y;
      dt[3*i+2]=(float)z;
      i++;
    }
  }

  return ((char*)0);
}
